diff -urN linux.store/linux/arch/arm/drivers/block/hd.c linux/arch/arm/drivers/block/hd.c
--- linux.store/linux/arch/arm/drivers/block/hd.c	Sun Mar  3 12:24:12 1996
+++ linux/arch/arm/drivers/block/hd.c	Mon Mar 11 22:48:13 1996
@@ -118,8 +118,7 @@
 	unsigned long t, flags;
 	int i;
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	t = jiffies * 11932;
     	outb_p(0, 0x43);
 	i = inb_p(0x40);
@@ -732,11 +731,11 @@
 		return;
 repeat:
 	timer_active &= ~(1<<HD_TIMER);
-	sti();
+	sti ();
 	INIT_REQUEST;
 	if (reset) {
-		cli();
-		reset_hd();
+		cli ();
+		reset_hd ();
 		return;
 	}
 	dev = MINOR(CURRENT->rq_dev);
@@ -745,44 +744,43 @@
 	if (dev >= (NR_HD<<6) || block >= hd[dev].nr_sects || ((block+nsect) > hd[dev].nr_sects)) {
 #ifdef DEBUG
 		if (dev >= (NR_HD<<6))
-			printk("hd: bad minor number: device=0x%04x\n", CURRENT->rq_dev);
+			printk ("hd: bad minor number: device=0x%04x\n", CURRENT->rq_dev);
 		else
-			printk("hd%c: bad access: block=%d, count=%d\n",
+			printk ("hd%c: bad access: block=%d, count=%d\n",
 				(dev>>6)+'a', block, nsect);
 #endif
-		end_request(0);
+		end_request (0);
 		goto repeat;
 	}
 	block += hd[dev].start_sect;
-	if(dev & 0x3f)
-	{ /* map sectors block to block+nsect to frags, 
-	   */
-		if(!image_file_check(CURRENT->rq_dev,CURRENT->cmd))
+	if (dev & 0x3f) {
+	 /* map sectors block to block+nsect to frags, 
+	  */
+		if (!image_file_check(CURRENT->rq_dev,CURRENT->cmd)) {
+			end_request (0);
 			goto repeat;
+		}
 		frag_count = image_file_map(CURRENT->rq_dev, block, nsect, MAX_FRAGS, 
 						frag_start, frag_len);
-		if(!frag_count)
-		{
+		if (!frag_count) {
+			end_request (0);
 			goto repeat;
 		}
 		
 		block = frag_start[0];
 		frag_sectors = nsect = frag_len[0];
 		frag_pos = 0;
-	}
-	else
-	{
+	} else {
 		frag_pos = 0;
 		frag_count = 1;
 		frag_sectors = nsect;
-		if(CURRENT->cmd == WRITE)
-		{ /* Protect normal HD from writes */
+		if (CURRENT->cmd == WRITE) { /* Protect normal HD from writes */
 			printk("hd%d : attempted write on protected drive\n",dev);
 			end_request(0);
 			goto repeat;
 		}
 	}
-	if(issue_request(dev,block,nsect, CURRENT))
+	if (issue_request(dev, block, nsect, CURRENT))
 		goto repeat;
 }
 
@@ -829,7 +827,7 @@
 int issue_request(int dev, unsigned int block, unsigned int nsect, struct request *current_req)
 {
 	unsigned int sec, track, head, cyl;
-int d = dev;
+	int d = dev;
 	dev >>= 6;
 	if (special_op[dev]) {
 		if (do_special_op(dev))
@@ -856,7 +854,6 @@
 		return 0;
 	}
 	if (current_req->cmd == WRITE) {
-#if 1
 #if 0
 		if (mult_count[dev])
 			hd_out(dev,nsect,sec,head,cyl,WIN_MULTWRITE,&multwrite_intr);
@@ -876,14 +873,6 @@
 		} else
 #endif
 			outsw(HD_DATA,current_req->buffer,256);
-if(d == 1 && block < 10) while(1);
-#else
-if(d == 1)
-		printk("write: buffer = %p (%08lX)\n", current_req->buffer, *(unsigned long *)current_req->buffer);
-{int i; for(i=0; i<0x003fffff; i++); }
-		end_request(0);
-		return 1;
-#endif
 		return 0;
 	}
 	panic("unknown hd-command");
@@ -978,8 +967,7 @@
 		case HDIO_SET_MULTCOUNT:
 			if (!suser()) return -EACCES;
 			if (MINOR(inode->i_rdev) & 0x3F) return -EINVAL;
-			save_flags(flags);
-			cli();	/* a prior request might still be in progress */
+			save_flags_cli (flags);	/* a prior request might still be in progress */
 			if (arg > max_mult[dev])
 				err = -EINVAL;	/* out of range for device */
 			else if (mult_req[dev] != mult_count[dev]) {
@@ -1067,25 +1055,25 @@
 }
 
 
-void set_hdinfo(int dev,unsigned char secsptrack,unsigned char heads,
+void hd_set_geometry (kdev_t dev,unsigned char secsptrack,unsigned char heads,
                     unsigned long discsize,unsigned int secsize)
 {
-  dev=MINOR(dev);
-  if(hd_info[dev>>6].cyl==1)
-  {
-    hd_info[dev>>6].cyl=discsize/(secsptrack*heads*secsize);
-    hd_info[dev>>6].head=heads;
-    hd_info[dev>>6].wpcom=-1;
-    hd_info[dev>>6].ctl=8;
-    hd_info[dev>>6].lzone=hd_info[dev>>6].cyl-1;
-    hd_info[dev>>6].sect=secsptrack;
-  }
-  hd[dev].start_sect=0;
-  hd[dev].nr_sects=discsize/secsize;
-#if 0
-  printk("hd%c: %d cylinders, %d heads, %d sectors (%d total)\n",'a'+(dev>>6),
-    hd_info[dev>>6].cyl, heads, secsptrack, discsize);
-#endif
+    int minor = MINOR(dev);
+    /*
+     * Only set the number of cylinders if the
+     * drive hasn't reported its geometery to the
+     * driver code yet.
+     */
+    if (hd_info[minor>>6].cyl == 1) {
+	hd_info[minor>>6].cyl = discsize/(secsptrack*heads*secsize);
+	hd_info[minor>>6].head = heads;
+	hd_info[minor>>6].wpcom = -1;
+	hd_info[minor>>6].ctl = 8;
+	hd_info[minor>>6].lzone = hd_info[dev>>6].cyl-1;
+	hd_info[minor>>6].sect = secsptrack;
+    }
+    hd[minor].start_sect = 0;
+    hd[minor].nr_sects = discsize / secsize;
 }
 
 /*
@@ -1099,53 +1087,63 @@
  */
 static void hd_geninit(struct gendisk *dev)
 {
-	int drive, i;
-
-NR_HD = 0;
-	if (!NR_HD) {
-	/* Default settings */
-		for (drive=0 ; drive<2 ; drive++) {
-			bios_info[drive].cyl	= hd_info[drive].cyl	= 1;
-			bios_info[drive].head	= hd_info[drive].head	= 1;
-			bios_info[drive].wpcom	= hd_info[drive].wpcom	= -1;
-			bios_info[drive].ctl	= hd_info[drive].ctl	= 8;
-			bios_info[drive].lzone	= hd_info[drive].lzone	= 1;
-			bios_info[drive].sect	= hd_info[drive].sect	= 17;
-			if(hd_info[drive].cyl && NR_HD == drive)
-				NR_HD++;
-		}
-        }
+    int drive, i;
 
+    if (!NR_HD) {
+	/*
+	 * Default settings
+	 *
+	 * If we don't know anything about the drive, then set it
+	 * so that we have enough to read the boot sector of the
+	 * ADFS drive.  This means that you *MUST* specify the
+	 * drive parameters of *all* drives if you have one IDE
+	 * drive that is not ADFS formatted.
+	 */
+	for (drive=0 ; drive<2 ; drive++) {
+	    bios_info[drive].cyl	= hd_info[drive].cyl	= 1;
+	    bios_info[drive].head	= hd_info[drive].head	= 1;
+	    bios_info[drive].wpcom	= hd_info[drive].wpcom	= -1;
+	    bios_info[drive].ctl	= hd_info[drive].ctl	= 8;
+	    bios_info[drive].lzone	= hd_info[drive].lzone	= 1;
+	    bios_info[drive].sect	= hd_info[drive].sect	= 17;
+	}
+	/*
+	 * We only set this to the one that the host OS gave us
+	 * if the user has not defined any types.
+	 */
 	NR_HD = no_hds;
+    }
 
-	i = NR_HD;
-	while (i-- > 0) {
-		/*
-		 * The newer E-IDE BIOSs handle drives larger than 1024
-		 * cylinders by increasing the number of logical heads
-		 * to keep the number of logical cylinders below the
-		 * sacred INT13 limit of 1024 (10 bits).  If that is
-		 * what's happening here, we'll find out and correct
-		 * it later when "identifying" the drive.
-		 */
-		hd[i<<6].nr_sects = bios_info[i].head *
-				bios_info[i].sect * bios_info[i].cyl;
-		hd_ident_info[i] = (struct hd_driveid *) kmalloc(512,GFP_KERNEL);
-		special_op[i] = 1;
-	}
-	if (NR_HD) {
-		if (request_irq(HD_IRQ, hd_interrupt, SA_INTERRUPT, "hd")) {
-			printk("hd: unable to get IRQ%d for the harddisk driver\n",HD_IRQ);
-			NR_HD = 0;
-		} else {
-			request_region(HD_DATA, 8, "hd");
-			request_region(HD_CMD, 1, "hd(cmd)");
-		}
+    i = NR_HD;
+    while (i-- > 0) {
+	/*
+	 * The newer E-IDE BIOSs handle drives larger than 1024
+	 * cylinders by increasing the number of logical heads
+	 * to keep the number of logical cylinders below the
+	 * sacred INT13 limit of 1024 (10 bits).  If that is
+	 * what's happening here, we'll find out and correct
+	 * it later when "identifying" the drive.
+	 */
+	hd[i<<6].nr_sects = bios_info[i].head *
+		bios_info[i].sect * bios_info[i].cyl;
+	hd_ident_info[i] = (struct hd_driveid *) kmalloc(512,GFP_KERNEL);
+	special_op[i] = 1;
+    }
+
+    if (NR_HD) {
+	if (request_irq(HD_IRQ, hd_interrupt, SA_INTERRUPT, "hd")) {
+	    printk("hd: unable to get IRQ%d for the harddisk driver\n",HD_IRQ);
+	    NR_HD = 0;
+	} else {
+	    request_region(HD_DATA, 8, "hd");
+	    request_region(HD_CMD, 1, "hd(cmd)");
 	}
-	hd_gendisk.nr_real = NR_HD;
+    }
+    hd_gendisk.nr_real = NR_HD;
 
-	for(i=0;i<(MAX_HD << 6);i++) hd_blocksizes[i] = 1024;
-	blksize_size[MAJOR_NR] = hd_blocksizes;
+    for (i = 0; i < (MAX_HD << 6); i++)
+	hd_blocksizes[i] = 1024;
+    blksize_size[MAJOR_NR] = hd_blocksizes;
 }
 
 static struct file_operations hd_fops = {
@@ -1203,8 +1201,7 @@
 	target =  DEVICE_NR(dev);
 	gdev = &GENDISK_STRUCT;
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	if (DEVICE_BUSY || USAGE > maxusage) {
 		restore_flags(flags);
 		return -EBUSY;
diff -urN linux.store/linux/arch/arm/drivers/block/hdsrch.c linux/arch/arm/drivers/block/hdsrch.c
--- linux.store/linux/arch/arm/drivers/block/hdsrch.c	Sun Mar  3 12:29:41 1996
+++ linux/arch/arm/drivers/block/hdsrch.c	Mon Mar 11 23:51:02 1996
@@ -11,6 +11,8 @@
 #include <linux/ctype.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
+#include <linux/kdev_t.h>
+#include <linux/major.h>
 #include <linux/malloc.h>
 #include <linux/string.h>
 #include <linux/genhd.h>
@@ -19,8 +21,6 @@
 
 #define MAX_BLK_FRAGS 64
 
-extern void print_minor_name (struct gendisk *hd, int minor);
-
 struct boot_block
 {
   unsigned char  log2secsize;
@@ -42,31 +42,32 @@
 };
 
 static struct boot_block *boot=NULL;
+static void *map=NULL;
 static unsigned int zonesize;
 static unsigned int idsperzone;
 static long rootaddr;
 static long mapaddr;
 static long maplen;
-static void *map=NULL;
-static char ignoring;
+static kdev_t ignoring;
 
-static int read_sectors(int dev,void *ptr,long address,int size)
+static int read_sectors(kdev_t dev, void *ptr, long address, int size)
 {
   struct buffer_head *bh;
-  char *p=ptr;
-  while(size>0) {
-    if((bh=bread(dev,address/1024,1024))) {
-      memcpy(p,bh->b_data+((address & 0x200)?512:0),(address & 0x200 || size<1024)?512:1024);
-      if(address & 0x200) {
+  char *p = ptr;
+  while (size > 0) {
+    if ((bh = bread(dev, address / 1024, 1024))) {
+      memcpy (p, bh->b_data + ((address & 0x200) ? 512 : 0),
+		(address & 0x200 || size < 1024) ? 512 : 1024);
+      if (address & 0x200) {
       	p -= 512;
         address -= 512;
         size += 512;
       }
     } else {
-      printk("hda%c: bread failed\n",'a'+((dev & 0xc0)>>6));
+      printk ("Device %s: bread failed\n", kdevname(dev));
       return 0;
     }
-    brelse(bh);
+    brelse (bh);
     p += 1024;
     address += 1024;
     size -= 1024;
@@ -74,27 +75,46 @@
   return 1;
 }
 
+static void set_hdinfo (kdev_t dev, unsigned char sectspertrack, unsigned char heads,
+		unsigned long disksize, unsigned int sectorsize)
+{
+    extern void hd_set_geometry (kdev_t dev, unsigned char, unsigned char, unsigned long, unsigned int);
+    extern void xd_set_geometry (kdev_t dev, unsigned char, unsigned char, unsigned long, unsigned int);
+
+    switch (MAJOR(dev)) {
+#ifdef CONFIG_BLK_DEV_HD
+    case HD_MAJOR:
+	hd_set_geometry (dev, sectspertrack, heads, disksize, sectorsize);
+	break;
+#endif
+
+#ifdef CONFIG_BLK_DEV_XD
+    case XD_MAJOR:
+	xd_set_geometry (dev, sectspertrack, heads, disksize, sectorsize);
+	break;
+#endif
+    }
+}
+
 /* + Read boot block at disc address &C00 (sector 6)
  * + Calculate map address & length
  */
-
-static int getdiskinfo(int dev)
+static int getdiskinfo(kdev_t dev)
 {
   char *ptr;
-  extern void set_hdinfo(int,unsigned char,unsigned char,unsigned long,unsigned int);
 
   if(boot)
   	return 1;
 
   boot=(struct boot_block *)kmalloc(sizeof(struct boot_block),GFP_KERNEL);
-  if(!boot) {
-    printk("hda%c: out of memory for bootblock\n",(dev>>6)+'a');
+  if (!boot) {
+    printk("Device %s: out of memory for bootblock\n", kdevname(dev));
     return 0;
   }
 
   ptr=(char *)kmalloc(1024,GFP_KERNEL);
-  if(!ptr) {
-    printk("hda%c: out of memory for bootblock\n",(dev>>6)+'a');
+  if (!ptr) {
+    printk("Device %s: out of memory for bootblock\n", kdevname(dev));
     return 0;
   }
 
@@ -126,7 +146,7 @@
   return check;
 }
 
-static int get_map(int dev)
+static int get_map(kdev_t dev)
 {
   if(!getdiskinfo(dev))
     return 0;
@@ -146,7 +166,7 @@
       return 0;
     if(map_cross_valid_byte()!=0xFF) {
       printk("Map 2 has invalid cross check - ignoring drive\n");
-      ignoring=dev;
+      ignoring = dev;
       return 0;
     }
   }
@@ -250,7 +270,7 @@
   }
 }
 
-static unsigned long scandir(int dev,unsigned long diraddress,char *file,int *type,
+static unsigned long scandir(kdev_t dev,unsigned long diraddress,char *file,int *type,
        unsigned long *length)
 {
   unsigned char *dir;
@@ -289,7 +309,7 @@
   return addr;
 }
 
-static int search_path(int dev,char *path,unsigned long *start,unsigned long *length, int maxbits)
+static int search_path(kdev_t dev,char *path,unsigned long *start,unsigned long *length, int maxbits)
 {
   unsigned long dir,iad,len;
   int type,i,n,fzones[MAX_BLK_FRAGS],fstart[MAX_BLK_FRAGS],fend[MAX_BLK_FRAGS];
@@ -386,7 +406,6 @@
 }
 
 #define MAX_HD_IMAGES	8
-#define TWO_HDS
 #define MAX_HD_BITS	128
 
 static int initialised[MAX_HD_IMAGES];
@@ -409,75 +428,122 @@
   {0,},
   {0,},
   {0,},
+  {0,},
+  {0,},
+  {0,},
+  {0,},
   {0,}
 };
 
+/* 
+ * This function  maps a device major/minor to the internal image file number
+ */
+static inline int get_dev (kdev_t dev, char *where)
+{
+    switch (MAJOR(dev)) {
+#ifdef CONFIG_BLK_DEV_HD
+    case HD_MAJOR:	/* IDE drives */
+#elif defined(CONFIG_BLK_DEV_XD)
+    case XD_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
+#endif
+	if ((MINOR(dev) & 0x3f) < 1 || (MINOR(dev) & 0x3f) > 0x14) {
+	    printk ("%s: bad device %s\n", where, kdevname (dev));
+	    return -1;
+	}
+	switch (MINOR(dev) & 0xc0) {
+	case 0x00:  return (MINOR(dev) - 1) & 3;
+	case 0x40:  return ((MINOR(dev) - 1) & 3) + 4;
+	default:
+	    printk ("%s: bad device %s\n", where, kdevname (dev));
+	    return -1;
+	}
+
+    default:
+        printk ("%s: unsupported device %s\n", where, kdevname (dev));
+        return -1;
+    }
+}
+
 /*
  * Get the sectors used by device 'dev'
  */
-int image_allocate_list(int dev,int devno,struct hd_struct *part)
+int image_allocate_list(kdev_t dev, int devno, struct hd_struct *part)
 {
-	unsigned long chk1=0,chk2=0;
-	int i,sects=0;
+    unsigned long chk1 = 0, chk2 = 0;
+    int i, sects = 0;
 
-#ifndef TWO_HDS
-	if(dev!=0x300)
-	{
-		printk("Can't cope with >1 hd!\n");
+    switch (MAJOR(dev)) {
+#ifdef CONFIG_BLK_DEV_HD
+    case HD_MAJOR:	/* IDE drives */
+#elif defined(CONFIG_BLK_DEV_XD)
+    case XD_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
+#endif	
+	switch (MINOR(dev) & 0xc0) {
+	case 0x00:
+	    if (devno == 0 || devno > 4) {
+		printk ("image_allocate_list: only 4 images per drive allowed\n");
 		return 0;
-	}
-#else
-	if(dev!=0x300 && dev!=0x340)
-	{
-		printk("Can't cope with >2 hds! (device %02X:%02X)\n",dev>>8,dev & 255);
+	    }
+	    devno = devno - 1;
+	    break;
+	case 0x40:
+	    devno &= 0x3f;
+	    if (devno == 0 || devno > 4) {
+		printk ("image_allocate_list: only 4 images per drive allowed\n");
 		return 0;
+	    }
+	    devno = devno + 3;
+	    break;
+	default:
+	    printk ("image_allocate_list: only two IDE drives supported\n");
+	    return 0;
 	}
-	if(dev == 0x340)
-	  devno=(devno & 0x3f) + 4;
-#endif
-
-	if(ignoring==dev)
-		return 0;
+	break;
+    default:
+	printk ("image_allocate_list: only IDE drives supported: %s\n", kdevname (dev));
+	return 0;
+    }
 
-	devno--;
+    if (ignoring == dev)
+	return 0;
 
-	if(devno > MAX_HD_IMAGES)
-		return 0;
+    if (devno > MAX_HD_IMAGES)
+	return 0;
 
-	if(!arc_hd_files[devno][0])
-		return 0;
+    if (!arc_hd_files[devno][0])
+	return 0;
 
 #ifndef NOT_YET_TESTED
-	maxblock[devno]=search_path(dev,arc_hd_files[devno],startaddr[devno],lengthaddr[devno],MAX_HD_BITS);
+    maxblock[devno] = search_path(dev, arc_hd_files[devno], startaddr[devno], lengthaddr[devno], MAX_HD_BITS);
 #else
-	maxblock[devno]=search_path(dev,arc_hd_files[devno],startaddr[devno],lengthaddr[devno],0);
+    maxblock[devno] = search_path(dev, arc_hd_files[devno], startaddr[devno], lengthaddr[devno], 0);
 #endif
-	if(maxblock[devno]>MAX_HD_BITS)
-		panic("image allocator: image file is too fragmented\n");
-	if(!maxblock[devno])
-		return 0;
+    if (maxblock[devno] > MAX_HD_BITS)
+	panic ("image_allocate_list: image file is too fragmented\n");
+
+    if (!maxblock[devno])
+	return 0;
 
-	for(i=0; i<maxblock[devno]; i++)
-	{
-		/* convert to blocks & calculate checksums */
+    for (i = 0; i < maxblock[devno]; i++) {
+	/* convert to blocks & calculate checksums */
 #define ADDR2BLOCK(x) ((x)>>9)
-		startaddr[devno][i]=ADDR2BLOCK(startaddr[devno][i]);
-		lengthaddr[devno][i]=ADDR2BLOCK(lengthaddr[devno][i]);
-		chk1^=startaddr[devno][i];
-		chk2^=lengthaddr[devno][i];
-		sects+=lengthaddr[devno][i];
-	}
-	startchk[devno]=chk1;
-	lengthchk[devno]=chk2;
-	initialised[devno]=1;
-	part->start_sect=0;
-	part->nr_sects=sects;
+	startaddr[devno][i] = ADDR2BLOCK(startaddr[devno][i]);
+	lengthaddr[devno][i] = ADDR2BLOCK(lengthaddr[devno][i]);
+	chk1 ^= startaddr[devno][i];
+	chk2 ^= lengthaddr[devno][i];
+	sects += lengthaddr[devno][i];
+    }
+    startchk[devno] = chk1;
+    lengthchk[devno] = chk2;
+    initialised[devno] = 1;
+    part->start_sect = 0;
+    part->nr_sects = sects;
 
 #ifdef DEBUG
-	for(i=0;i<n;i++)
-		printk("%10X : %10X\n",start[devno][i],length[devno][i]);
+    for (i = 0; i < n; i++)
+	printk ("%10X : %10X\n",start[devno][i],length[devno][i]);
 #endif
-	return 1;
+    return 1;
 }
 
 /*
@@ -486,80 +552,58 @@
  * This must be called before accessing a new device
  */
 
-void image_release_dev(int dev)
+void image_release_dev (kdev_t dev)
 {
-  if(boot) {
-    kfree_s(boot,sizeof(struct boot_block));
-    boot=NULL;
-  }
+    if(boot) {
+	kfree (boot);
+	boot = NULL;
+    }
 
-  if(map) {
-    vfree(map);
-    map = NULL;
-  }
+    if(map) {
+	vfree (map);
+	map = NULL;
+    }
 
-  ignoring=0;
+    ignoring = 0;
 }
 
 /* 
- * This macro maps a device major/minor to the internal image file number
- */
-#ifndef TWO_HDS
-#define GET_DEV(dev) \
-	if((dev)<0x301 || (dev)>0x314) \
-	{ \
-		printk("Bad device %X passed to image_file_check\n",(dev)); \
-		return 0; \
-	} \
-	(dev)=((dev)-1) & 3;
-#else
-#define GET_DEV(dev) \
-	if(((dev) & 0x33F)<0x301 || ((dev) & 0x33F)>0x314) \
-	{ \
-		printk("Bad device %X passed to image_file_check\n",(dev)); \
-		return 0; \
-	} \
-	switch((dev) & 0xC0) \
-	{ \
-		case 0x00: (dev)=((dev) -1) & 3;     break;\
-		case 0x40: (dev)=(((dev) -1) & 3)+4; break;\
-	}
-#endif
-
-/* 
  * This function is called to perform checks on the image file.
  *  Checks made: Image file has been initialised, and
  *     for writes, the checksums on the start/length data are correct.
  */
-int image_file_check(int dev,int cmd)
+int image_file_check (kdev_t dev,int cmd)
 {
-	long chk1=0,chk2=0;
-	int i;
+    unsigned long chk1 = 0, chk2 = 0;
+    int i, internal_dev;
 
-	GET_DEV(dev);
+    internal_dev = get_dev (dev, "image_file_check");
 
-	if (!initialised[dev]) {
-		printk("hd%c%d: %s of uninitialised image file.\n",(dev>>6)+'a',dev & 0x3f,
-		  cmd==WRITE?"write":"read");
-		return 0;
-	}
+    if (internal_dev < 0)
+	return 0;
 
-	if (cmd==WRITE) {
-		/*
-		 * Check the table! Just in case. We don't want to write to a part of the HD that
-		 * is not allocated to us! It might be the map or something!
-		 */
-		for(i=0; i<maxblock[dev]; i++) {
-		  	chk1^=startaddr[dev][i];
-		  	chk2^=lengthaddr[dev][i];
-		}
-		if(chk1!=startchk[dev] || chk2!=lengthchk[dev]) {
-			printk("hda%c%d: mapping tables corrupted on write.",
-				(dev>>6)+'a',dev & 0x3f);
-			return 0;
-		}
+    if (!initialised[internal_dev]) {
+	printk ("hd%c%d: %s of uninitialised image file.\n",
+	    (dev >> 6) + 'a', dev & 0x3f, cmd == WRITE ? "write" : "read");
+	return 0;
+    }
+
+    if (cmd == WRITE) {
+	/*
+	 * Check the table! Just in case. We don't want to write to a part of the HD that
+	 * is not allocated to us! It might be the map or something!
+	 */
+	for(i = 0; i < maxblock[internal_dev]; i++) {
+	    chk1 ^= startaddr[internal_dev][i];
+	    chk2 ^= lengthaddr[internal_dev][i];
 	}
-	return 1;
+	if (chk1 != startchk[internal_dev] || chk2 != lengthchk[internal_dev]) {
+	    printk ("hda%c%d: mapping tables corrupted on write.",
+			(dev >> 6) + 'a', dev & 0x3f);
+	    return 0;
+	}
+    }
+    return 1;
 }
 
 /*
@@ -567,43 +611,43 @@
  * or the number of entries.  This is called quite often when accessing
  * image files.
  */
-int image_file_map(int dev,unsigned long reqblock,unsigned long reqlength,
-		    unsigned long max_reqs,
-                    unsigned long *block,unsigned long *length)
-{
-	int i,num=0;
-	unsigned long blk=reqblock,totlen=0;
-
-	GET_DEV(dev);
-
-	for(i=0; i<maxblock[dev]; i++)
-	{
-		long remainder;
-		totlen+=lengthaddr[dev][i];
-		if(reqblock >= lengthaddr[dev][i])
-		{
-			reqblock-=lengthaddr[dev][i];
-			continue;
-		}
-		block[num]=reqblock+startaddr[dev][i];
-		remainder=reqblock+reqlength-lengthaddr[dev][i];
-		if(remainder<=0)
-		{
-			length[num]=reqlength;
-			return num+1;
-		}
-		length[num]=lengthaddr[dev][i]-reqblock;
-		if(num+1 >= max_reqs)
-			return num+1;
-		reqblock=0;
-		reqlength=remainder;
-		num++;
-	}
+int image_file_map(kdev_t dev, unsigned long reqblock, unsigned long reqlength,
+		    unsigned long max_reqs, unsigned long *block, unsigned long *length)
+{
+    unsigned long blk = reqblock, totlen = 0;
+    int i, num = 0;
+    int internal_dev;
+
+    internal_dev = get_dev (dev, "image_file_map");
 
-	printk("hd%c%d: attempted read for sector %ld past end if image file at %ld.\n",
-		(dev>>6)+'a',dev & 0x3f,blk,totlen);
-		/* Should never happen! */
+    if (internal_dev < 0)
 	return 0;
+
+    for (i = 0; i < maxblock[internal_dev]; i++) {
+	long remainder;
+	totlen += lengthaddr[internal_dev][i];
+	if (reqblock >= lengthaddr[internal_dev][i]) {
+	    reqblock -= lengthaddr[internal_dev][i];
+	    continue;
+	}
+	block[num] = reqblock + startaddr[internal_dev][i];
+	remainder = reqblock + reqlength - lengthaddr[internal_dev][i];
+	if (remainder <= 0) {
+	    length[num] = reqlength;
+	    return num + 1;
+	}
+	length[num] = lengthaddr[internal_dev][i] - reqblock;
+	if (num + 1 >= max_reqs)
+	    return num + 1;
+	reqblock = 0;
+	reqlength = remainder;
+	num++;
+    }
+
+    printk ("hd%c%d: attempted read for sector %ld past end if image file at %ld.\n",
+	(dev >> 6) + 'a', dev & 0x3f, blk, totlen);
+	/* Should never happen! */
+    return 0;
 }
 
 
